# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <assert.h>
# include <math.h>
# include "datastruct.h"

int popsize;
int ngen;
int nobj;
int real;
int nruns;
int pfsize;
int m, n, r, t;
char ** mem;
int betterhyp;

double ratio_hyp;

char * a[] = {"a-0.0", "a-0.2", "a-0.4", "a-0.6", "a-0.8", "a-1.0"};
char * b[] = {"b-0.0", "b-0.2", "b-0.4", "b-0.6", "b-0.8", "b-1.0"};
char * c[] = {"c-0.0", "c-0.2", "c-0.4", "c-0.6", "c-0.8", "c-1.0"};
char * d[] = {"d-0.0", "d-0.2", "d-0.4", "d-0.6", "d-0.8", "d-1.0"};

// compute crowding distance for all individuals
// of population pop
double crowd(population *pop, double **bounds) {
int i, j, xtremes;
double leftn, rightn, meandi;
int *sort;

sort = (int*) malloc(pop->size*sizeof(int));
for (i = 0; i < pop->size; i++)
	pop->ind[i].affinity = 0.0;
for (i = 0; i < nobj; i++) {
	for (j = 0; j < pop->size; j++)
		sort[j] = j;
	myqsort(pop, 0, pop->size - 1, i, sort);
	for (j = 1; j < pop->size - 1; j++) {
		leftn = ((pop->ind[sort[j - 1]].obj[i]));
		rightn = ((pop->ind[sort[j + 1]].obj[i]));
		pop->ind[sort[j]].affinity += (double) pow((double)(rightn - leftn), 2.0);
	}
}
meandi = 0.0;
xtremes = 0;
for (i = 0; i < pop->size; i++) {
	if (pop->ind[i].affinity==0.0) {
		xtremes++;
	} else {
		//printf("affinity : %f\n", pop->ind[i].affinity);
		pop->ind[i].affinity = sqrt(pop->ind[i].affinity);
		meandi += pop->ind[i].affinity;
	}
}
//printf("meandi -> %f\n", meandi);
meandi = meandi / (double) (popsize-xtremes);
// calculate sum1 of |di-dmean|
double sum1 = 0.0;
for (i = 0; i < pop->size; i++) {
	if (pop->ind[i].affinity!=0.0)
		sum1 += absreal(pop->ind[i].affinity-meandi);
	pop->ind[i].affinity=0.0;
}

for (i = 0; i < nobj; i++) {
	for (j = 0; j < pop->size; j++) sort[j] = j;
	myqsort(pop, 0, pop->size - 1, i, sort);
	for (j=0; j< nobj; j++) {
		pop->ind[sort[pop->size - 1]].affinity += pow(bounds[i][j]-pop->ind[sort[pop->size-2]].obj[j],2.0);
	}
}

double sum2 = 0.0;
for (i = 0; i < pop->size; i++) {
	if (pop->ind[i].affinity!=0.0) {
		//printf("aff : %f\n", pop->ind[i].affinity);
		pop->ind[i].affinity = sqrt(pop->ind[i].affinity);
		sum2 += pop->ind[i].affinity;
	}
}
//printf("sum2 = %f\n",sum2);

free(sort);
//printf("return : %f\n", (sum2+sum1)/((sum2+(popsize-xtremes)*meandi)));
return ((sum2+sum1)/((sum2+(popsize-xtremes-1)*meandi)));
}

int c2s(population * pop1, population * pop2) {
	int i,j;
	int res = 0;
	for (i=0;i<pop1->size;i++) {
		for (j=0;j<pop2->size;j++) {
			res += dominate(&(pop1->ind[i]), &(pop2->ind[j]));
		}
	}
	return res;
}

void comp_spread(population ** nsga, population ** isahv, population * pf) {

int i, j, k;
double ** bounds;
double *sprd1, *sprd2;
double meansprd1, meansprd2;
double stddev1, stddev2;
int *sort;

sort = (int*) malloc(pf->size*sizeof(int));

sprd1 = malloc(nruns*sizeof(double));
sprd2 = malloc(nruns*sizeof(double));

bounds = malloc(nobj*sizeof(double *));
for (i=0;i<nobj;i++) {
	bounds[i] = malloc(nobj*sizeof(double));
}

// init bounds of pareto front
for (i=0;i<nobj;i++) {
	for (j=0;j<nobj;j++)
		bounds[i][j] = -INF;
}
// compute bounds
for (i=0;i<nobj;i++) {
	for (j = 0; j < pf->size; j++) sort[j] = j;
	myqsort(pf, 0, pf->size - 1, i, sort);
	for (j = 0; j < nobj; j++) {
		bounds[i][j] = pf->ind[sort[pf->size-1]].obj[j];
	}
}

for (j=0;j<nobj;j++) {
	//printf("bounds : ");
	for (k=0;k<nobj;k++) {
	//printf("%f ", bounds[j][k]);
	}
	//printf("\n");
}


// pour tous les runs
for (i=0;i<nruns;i++) {
	sprd1[i] = crowd(nsga[i], bounds);
	//printf("spread nsga : %f\n", sprd1[i]);
	sprd2[i] = crowd(isahv[i], bounds);
	//printf("spread isahv : %f\n", sprd2[i]);
}

meansprd1 = 0.0;
for (i=0;i<nruns;i++)
	meansprd1 += sprd1[i];
meansprd1 = (double) meansprd1/(double)nruns;

stddev1 = 0.0;
for (i=0;i<nruns;i++) {
	 stddev1 += pow(meansprd1-sprd1[i],2.0);
}
stddev1 = (double)  stddev1/nruns;
//stddev1 = sqrt(stddev1);

meansprd2 = 0.0;
for (i=0;i<nruns;i++)
	meansprd2 += sprd2[i];
meansprd2 = (double) meansprd2/(double)nruns;

stddev2 = 0.0;
for (i=0;i<nruns;i++) {
	 stddev2 += pow(meansprd2-sprd2[i],2.0);
}
stddev2 = (double)  stddev2/nruns;
//stddev2 = sqrt(stddev2);


printf("SPREAD      (A1): & ");
if (meansprd1<meansprd2)
	printf("\\bf{%e} & ", meansprd1);
else
	printf("%e & ", meansprd1);
if (stddev1<stddev2) 
	printf("\\bf{%e} \\\\ \n",stddev1);
else 
	printf("%e \\\\ \n",stddev1);
printf("SPREAD      (A2): & "); 
if (meansprd1>meansprd2)
	printf("\\bf{%e} & ", meansprd2);
else
	printf("%e & ", meansprd2);
if (stddev1>stddev2)  
	printf("\\bf{%e} \\\\ \n",stddev2);
else 
	printf("%e \\\\ \n",stddev2);



for (i=0;i<nobj;i++) {
	free(bounds[i]); 
}
free(bounds);
free(sprd1);
free(sprd2);
	
}

void comp_cov2pf(population ** nsga, population ** isahv, population * pf) {

	int i;
	int *a1_c2s, *a2_c2s;
	double a1_c2s_mean, a2_c2s_mean;
	double stddev1, stddev2;
		
	a1_c2s = (int*) malloc(nruns*sizeof(int));
	a2_c2s = (int*) malloc(nruns*sizeof(int));
	
	for (i=0;i<nruns;i++) {
			a1_c2s[i] = c2s(pf, nsga[i]);
			a2_c2s[i] = c2s(pf, isahv[i]);
	}
	
	a1_c2s_mean = 0.0;
	for (i=0;i<nruns;i++) {
		a1_c2s_mean += a1_c2s[i];
	}
	a1_c2s_mean = (double) a1_c2s_mean/(double)nruns;
	
	stddev1 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev1 += pow(a1_c2s_mean-a1_c2s[i],2.0);
	}
	stddev1 = (double)  stddev1/nruns;
	stddev1 = sqrt(stddev1);
	
	a2_c2s_mean = 0.0;
	for (i=0;i<nruns;i++) {
		a2_c2s_mean += a2_c2s[i];
	}
	a2_c2s_mean = (double) a2_c2s_mean/nruns;
	
	stddev2 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev2 += pow(a2_c2s_mean-a2_c2s[i],2.0);
	}
	stddev2 = (double)  stddev2/nruns;
	stddev2 = sqrt(stddev2);

	printf("COV2SETS (PF/A1): & ");
	if (a1_c2s_mean<a2_c2s_mean)
		printf("\\bf{%e} & ", a1_c2s_mean);
	else
		printf("%e & ", a1_c2s_mean);
	if (stddev1<stddev2) 
		printf("\\bf{%e} \\\\ \n",stddev1);
	else 
		printf("%e \\\\ \n",stddev1);

	printf("COV2SETS (PF/A2): & "); 
	if (a1_c2s_mean>a2_c2s_mean)
		printf("\\bf{%e} & ", a2_c2s_mean);
	else
		printf("%e & ", a2_c2s_mean);
	if (stddev1>stddev2)  
		printf("\\bf{%e} \\\\ \n",stddev2);
	else 
		printf("%e \\\\ \n",stddev2);




	free(a1_c2s);
	free(a2_c2s);
}


void comp_cov2sets(population ** nsga, population ** isahv) {

	int i;
	int *a1_c2s, *a2_c2s;
	double a1_c2s_mean, a2_c2s_mean;
	double stddev1, stddev2;
		
	a1_c2s = (int*) malloc(nruns*sizeof(int));
	a2_c2s = (int*) malloc(nruns*sizeof(int));
	
	
	for (i=0;i<nruns;i++) {
			a1_c2s[i] = c2s(nsga[i], isahv[i]);
			a2_c2s[i] = c2s(isahv[i], nsga[i]);
	}

	a1_c2s_mean = 0.0;
	for (i=0;i<nruns;i++) {
		a1_c2s_mean += (double) a1_c2s[i];
	}
	a1_c2s_mean = (double) a1_c2s_mean/nruns;

	stddev1 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev1 += pow(a1_c2s_mean-a1_c2s[i],2.0);
	}
	stddev1 = (double)  stddev1/nruns;
	stddev1 = sqrt(stddev1);
	
	a2_c2s_mean = 0.0;
	for (i=0;i<nruns;i++) {
		a2_c2s_mean += (double) a2_c2s[i];
	}
	a2_c2s_mean = (double) a2_c2s_mean/nruns;
	
	stddev2 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev2 += pow(a2_c2s_mean-a2_c2s[i],2.0);
	}
	stddev2 = (double)  stddev2/nruns;
	stddev2 = sqrt(stddev2);


	printf("COV2SETS (A1/A2): & ");
	if (a1_c2s_mean>a2_c2s_mean)
		printf("\\bf{%e} & ", a1_c2s_mean);
	else
		printf("%e & ", a1_c2s_mean);
	if (stddev1<stddev2) 
		printf("\\bf{%e} \\\\ \n",stddev1);
	else 
		printf("%e \\\\ \n",stddev1);

	printf("COV2SETS (A2/A1): & "); 
	if (a1_c2s_mean<a2_c2s_mean)
		printf("\\bf{%e} & ", a2_c2s_mean);
	else
		printf("%e & ", a2_c2s_mean);
	if (stddev1>stddev2)  
		printf("\\bf{%e} \\\\ \n",stddev2);
	else 
		printf("%e \\\\ \n",stddev2);
	
	free(a1_c2s);
	free(a2_c2s);
}
void comp_igd(population ** nsga, population ** isahv, population * pf) {
	int i, j, k;
	double *min_a1, *min_a2, *pop1dist, *pop2dist;
	double tmp, mean_igdpop1, mean_igdpop2;
	double stddev1, stddev2;
	
	min_a1 = malloc(pf->size*sizeof(double));
	min_a2 = malloc(pf->size*sizeof(double));
	
	pop1dist = malloc(nruns*sizeof(double));
	pop2dist = malloc(nruns*sizeof(double));
	
	for (i=0; i<nruns;i++) {
		pop1dist[i] = 0.0;
		pop2dist[i] = 0.0;
	}

	mean_igdpop1 = 0.0;
	mean_igdpop2 = 0.0;

	for (i=0;i<nruns;i++) {

			for (j=0; j< pf->size; j++) {
				min_a1[j] = INF;
				min_a2[j] = INF; 
			}
			// calculate minimal euclidean distance between 
			// pareto front and one solution of pop1
			for (j=0; j< pf->size; j++) {
				for (k=0; k< nsga[i]->size; k++) {
					tmp = eucl_d(&(nsga[i]->ind[k]),&(pf->ind[j]));
					if (tmp<min_a1[j])
						min_a1[j] = tmp;
				}
			}
			// calculate minimal euclidean distance between 
			// pareto front and one solution of pop2
			for (j=0; j< pf->size; j++) {
				for (k=0; k< isahv[i]->size; k++) {
					tmp = eucl_d(&(isahv[i]->ind[k]),&(pf->ind[j]));
					if (tmp<min_a2[j])
						min_a2[j] = tmp;
				}
			}
			
			tmp = 0.0;
			for (j=0; j< pf->size; j++) {
				tmp += pow(min_a1[j],2.0); 
			}
			tmp = sqrt(tmp);
			pop1dist[i] = (double) tmp / ((double) pf->size);
			
			tmp = 0.0;
			for (j=0; j< pf->size; j++) {
				tmp += pow(min_a2[j],2.0); 
			}
			tmp = sqrt(tmp);
			pop2dist[i] = (double) tmp / ((double) pf->size);

			mean_igdpop1 += pop1dist[i];
			mean_igdpop2 += pop2dist[i];

	}
				
	mean_igdpop1 /= (double) nruns;
	mean_igdpop2 /= (double) nruns;

	stddev1 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev1 += pow(mean_igdpop1-pop1dist[i],2.0);
	}
	stddev1 = (double) stddev1/nruns;
	stddev1 = sqrt(stddev1);
	
	stddev2 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev2 += pow(mean_igdpop2-pop2dist[i],2.0);
	}
	stddev2 = (double) stddev2/nruns;
	stddev2 = sqrt(stddev2);

	printf("Inv-Gen-Dst (A1): & ");
	if (mean_igdpop1<mean_igdpop2) 
		printf("\\bf{%e} & ", mean_igdpop1);
	else
		printf("%e & ", mean_igdpop1);
	if (stddev1<stddev2) 
		printf("\\bf{%e} \\\\ \n",stddev1);
	else 
		printf("%e \\\\ \n",stddev1);

	printf("Inv-Gen-Dst  (A2): & "); 
	if (mean_igdpop1>mean_igdpop2)
		printf("\\bf{%e} & ", mean_igdpop2);
	else
		printf("%e & ", mean_igdpop2);
	if (stddev1>stddev2)  
		printf("\\bf{%e} \\\\ \n",stddev2);
	else 
		printf("%e \\\\ \n",stddev2);

	free(min_a1);
	free(min_a2);
	free(pop1dist);
	free(pop2dist);
}


void comp_hypervol(population ** nsga, population ** isahv, population * pf) {

	int i, j, k;
	double *min, *max, *ref, *a1_hvs, *a2_hvs, pf_hv;
	double a1_hvmean, a2_hvmean;
	double stddev1, stddev2;
	
	a1_hvs = (double*) malloc(nruns*sizeof(double));
	a2_hvs = (double*) malloc(nruns*sizeof(double));
	
	max = (double*) malloc(nobj*sizeof(double));
	min = (double*) malloc(nobj*sizeof(double));
	ref = (double*) malloc(nobj*sizeof(double));

	for (i=0;i<nobj;i++) {max[i]=-INF; min[i]=INF;}

	// Nsga get bounds
	for (i=0;i<nruns;i++) {
		for (j=0;j<nsga[i]->size;j++) {
			for(k=0;k<nobj;k++) {
				if (nsga[i]->ind[j].obj[k]<min[k]) min[k] = nsga[i]->ind[j].obj[k];
				if (nsga[i]->ind[j].obj[k]>max[k]) max[k] = nsga[i]->ind[j].obj[k];
			}
		}
	}

	// isahv get bounds

	for (i=0;i<nruns;i++) {
		for (j=0;j<isahv[i]->size;j++) {
			for(k=0;k<nobj;k++) {
				if (isahv[i]->ind[j].obj[k]<min[k]) min[k] = isahv[i]->ind[j].obj[k];
				if (isahv[i]->ind[j].obj[k]>max[k]) max[k] = isahv[i]->ind[j].obj[k];
			}
		}
	}

	// Pf get bounds
	for (j=0; j< pf->size; j++) {
		for (k=0;k<nobj;k++) {
			if (pf->ind[j].obj[k]<min[k]) min[k] = pf->ind[j].obj[k];
			if (pf->ind[j].obj[k]>max[k]) max[k] = pf->ind[j].obj[k];
		}
	}

	// Compute reference
	for (i = 0; i<nobj; i++)
		ref[i] = max[i]+ 0.1*(max[i]-min[i]);

	pf_hv = hv_compute(pf, &ref, NULL, NULL, pf->size, &nobj);

	for (i=0;i<nruns;i++) {
		a1_hvs[i] = hv_compute(nsga[i], &ref, NULL, NULL, nsga[i]->size, &nobj);
		//assert(a1_hvs[i] < pf_hv);
		//printf("nsga i: %d, hv :%e\n",i,a1_hvs[i]);
		
	}

	for (i=0;i<nruns;i++) {
		a2_hvs[i] = hv_compute(isahv[i], &ref, NULL, NULL, isahv[i]->size, &nobj);
		//assert(a2_hvs[i] < pf_hv);
		//printf("isahv i: %d, hv :%e\n",i,a2_hvs[i]);
	}

	a1_hvmean = 0.0;
	for (i=0;i<nruns;i++) {
		a1_hvmean += a1_hvs[i];
	}
	a1_hvmean = (double) a1_hvmean/nruns;
	
	stddev1 = 0.0;
	for (i=0;i<nruns;i++) {
		 stddev1 += pow(a1_hvmean-a1_hvs[i],2.0);
	}
	stddev1 = (double)  stddev1/nruns;
	stddev1 = sqrt(stddev1);

	
	a2_hvmean = 0.0;
	for (i=0;i<nruns;i++) {
		a2_hvmean += a2_hvs[i];
	}
	a2_hvmean = (double) a2_hvmean/nruns;

	
	stddev2 = 0.0;
	for (i=0;i<nruns;i++) {
		stddev2 += pow(a2_hvmean-a2_hvs[i], 2.0);
	}
	stddev2 = (double) stddev2/nruns;
	stddev2 = sqrt(stddev2);

	if (a2_hvmean>a1_hvmean) betterhyp = 1;
	else betterhyp = 0;


	if ((a2_hvmean/pf_hv)>ratio_hyp) {
			ratio_hyp = a2_hvmean/pf_hv;
			mem[0] = a[m];
			mem[1] = b[n];
			mem[2] = c[r];
			mem[3] = d[t];
	}



	printf("HYPERVOLUME (PF) & %e & - \\\\ \n",pf_hv);
	printf("HYPERVOLUME (A1): & ");
	if (a1_hvmean>a2_hvmean) 
		printf("\\bf{%e} & ", a1_hvmean);
	else
		printf("%e & ", a1_hvmean);
	if (stddev1<stddev2) 
		printf("\\bf{%e} \\\\ \n",stddev1);
	else 
		printf("%e \\\\ \n",stddev1);

	printf("HYPERVOLUME (A2): & "); 
	if (a1_hvmean<a2_hvmean)
		printf("\\bf{%e} & ", a2_hvmean);
	else
		printf("%e & ", a2_hvmean);
	if (stddev1>stddev2)  
		printf("\\bf{%e} \\\\ \n",stddev2);
	else 
		printf("%e \\\\ \n",stddev2);

	free(a1_hvs);
	free(a2_hvs);
	free(min);
	free(max);
	free(ref);
}


int main (int argc, char **argv) {

	int i, j, retval;
	FILE *param, *fictmp;
	char line[256];
	char *fn, *word, *error;
	population **nsga, **isahv, *pf;
		
	randomize();

	mem = malloc(5*sizeof(char*));
	for (i=0;i<5;i++)
		mem[i] = malloc(10*sizeof(char));

	mem[0] = "-1.0";

	ratio_hyp = -INF;	
	betterhyp = 0;

	if (argc<2) {
		printf("Usage ./compare prob_name\n");
		exit(1);
	}
	
	
	for (m=0; m<6; m++) {
		for (n=0; n<6; n++) {
			for (r=0; r<6; r++) {
				for (t=0; t<6; t++) {
	printf("\na: %s, b :%s, c :%s, d :%s\n",a[m],b[n], c[r], d[t]);
	nruns = 5;

	fn = malloc(100 * sizeof(char));
	sprintf(fn, "problems/%s.in", argv[1]);
	param = fopen(fn, "r");
	if (!param) {
		printf("Error : Can't open file problems/%s.in", argv[1]);
		exit(1);
	}
	free(fn);
	
	// Population
	error = fgets(line, 256, param);
	retval = sscanf(line,"%d", &popsize);
	if (popsize < 0) {
		printf("\n Wrong population size entered\n");
		exit(1);
	}

	// Number of generation
	error = fgets(line, 256, param);
	retval = sscanf(line,"%d", &ngen);
	if (ngen < 1) {
		printf("\n Wrong number of generations entered\n");
		exit(1);
	}

	// Number of objectives
	error = fgets(line, 256, param);
	retval = sscanf(line,"%d", &nobj);
	if (nobj < 1) {
		printf("\n Wrong number of objectives entered\n");
		exit(1);
	}

	// Pareto front size
	error = fgets(line, 256, param);
	retval = sscanf(line,"%d", &pfsize);
	if (pfsize < 1) {
		printf("\n Wrong Pareto front size\n");
		exit(1);
	}
	
	fclose(param);

	nsga = (population **) malloc(nruns * sizeof(population*));
	for(i=0; i<nruns; i++) {
		nsga[i] = (population *) malloc(sizeof(population));
		allocate_memory_pop(nsga[i], popsize);
		nsga[i]->size = 0;
	}
	isahv = (population **) malloc(nruns * sizeof(population*));
	for(i=0; i<nruns; i++) {
		isahv[i] = (population *) malloc(sizeof(population));
		allocate_memory_pop(isahv[i], popsize);
		isahv[i]->size = 0;
	}
	pf = (population *) malloc(sizeof(population));
	allocate_memory_pop(pf, pfsize);
	pf->size = 0;
	
	// Nsga results
	for (i=0;i<nruns;i++) {
		fn = malloc(100 * sizeof(char));
		sprintf(fn,"nsga2/%s/final%d.out",argv[1],i+1);
		fictmp = fopen(fn,"r");
		while (fgets(line, 256, fictmp)!=NULL) {
			word = strtok(line,"\t\n");
			j =0;
			while(word!=NULL) {
				nsga[i]->ind[nsga[i]->size].obj[j] = atof(word);
				word = strtok (NULL, "\t\n");
				j++;
			}	
			nsga[i]->size++;
		}
		free(fn);
		fclose(fictmp);
	}


	// isahv results
	for (i=0;i<nruns;i++) {
		fn = malloc(100 * sizeof(char));
		sprintf(fn,"isahv/%s/%s/%s/%s/%s/final%d.out", argv[1], a[m], b[n], c[r], d[t], i+1);
		fictmp = fopen(fn,"r");
		while (fgets(line, 256, fictmp)!=NULL) {
			word = strtok(line,"\t\n");
			j =0;
			while(word!=NULL) {
				isahv[i]->ind[isahv[i]->size].obj[j] = atof(word);
				word = strtok (NULL, "\t\n");
				j++;
			}
			isahv[i]->size++;
		}
		free(fn);
		fclose(fictmp);
	}



	// True Pareto front
	fn = malloc(100 * sizeof(char));
	sprintf(fn,"truepf/%s.dat",argv[1]);
	fictmp = fopen(fn,"r");

	while (fgets(line, 256, fictmp)!=NULL) {
		word = strtok(line,"\t\n");
		j =0;
		while(word!=NULL) {
			pf->ind[pf->size].obj[j] = atof(word);
			word = strtok (NULL, "\t\n");
			j++;
		}
		pf->size++;
	}

	assert(pf->size==pfsize);
	free(fn);
	fclose(fictmp);

	printf("Performance measure on 100 runs (mean values) :\n\tA1=NSGAII, A2=ISA-HV, PROB=%s, POPSIZE=%d\n",argv[1], popsize);

	printf("\\begin{tabular}{|l|c|c|}\n");
	printf("\\hline \n");
	printf("\\multicolumn{3}{|l|}{PROB=%s, A1=NSGAII, A2=AIS-HV} \\\\ \n", argv[1]);
	printf("\\multicolumn{3}{|l|}{POPSIZE=%d, PFSIZE = %d, RUNS=100} \\\\ \\hline \n", popsize, pfsize);
	printf("INDICATOR & MEAN & Std. Dev. \\\\ \\hline \n");
	comp_hypervol(nsga, isahv, pf);
	comp_igd(nsga, isahv, pf);
	comp_cov2sets(nsga, isahv);
	comp_cov2pf(nsga, isahv, pf);
	comp_spread(nsga, isahv, pf);
	printf("\\hline \n");
	printf("\\end{tabular}\n");
		
	for (i=0;i<nruns;i++) {
		deallocate_memory_pop(nsga[i], popsize);
		free(nsga[i]);
		deallocate_memory_pop(isahv[i], popsize);
		free(isahv[i]);
	}
	free(nsga);
	free(isahv);
	deallocate_memory_pop(pf, pf->size);
	free(pf);
	}}}}
	printf("%s : ", argv[1]);
	for (i=0;i<5;i++)
		printf("%s ",mem[i]);
	printf("\n");
	return 0;
}




