/*
 * qsort.c
 *
 *  Created on: Mar 1, 2011
 *      Author: Thomas PIERRARD
 */
# include <stdio.h>
# include <stdlib.h>

# include "datastruct.h"

void myqsort(population *pop, int m, int n, int obj, int * sort) {
	int pivot, i, j;
	double key;
	if (m < n) {
		pivot = rnd(m, n);
		swap(&(sort[m]), &(sort[pivot]));

		key = pop->ind[sort[m]].obj[obj];
		i = m + 1;
		j = n;
		while (i <= j) {
			while ((i <= n) && (pop->ind[sort[i]].obj[obj] <= key))
				i++;
			while ((j >= m) && (pop->ind[sort[j]].obj[obj] > key))
				j--;
			if (i < j)
				swap(&(sort[i]), &(sort[j]));
		}
		// swap two elements
		swap(&(sort[m]), &(sort[j]));
		// recursively sort the lesser list
		myqsort(pop, m, j - 1, obj, sort);
		myqsort(pop, j + 1, n, obj, sort);

	}
	return;
}


void myqsort_affinity_inv(population *pop, int m, int n, int * sort) {
	int pivot, i, j;
	double key;
	if (m < n) {
		pivot = rnd(m, n);
		swap(&(sort[m]), &(sort[pivot]));

		key = pop->ind[sort[m]].affinity;
		i = m + 1;
		j = n;
		while (i <= j) {
			while ((i <= n) && (pop->ind[sort[i]].affinity >= key))
				i++;
			while ((j >= m) && (pop->ind[sort[j]].affinity < key))
				j--;
			if (i < j)
				swap(&(sort[i]), &(sort[j]));
		}
		// swap two elements
		swap(&(sort[m]), &(sort[j]));
		// recursively sort the lesser list
		myqsort_affinity_inv(pop, m, j - 1, sort);
		myqsort_affinity_inv(pop, j + 1, n, sort);

	}
	return;
}

void myqsort_affinity(population *pop, int m, int n, int * sort) {
	int pivot, i, j;
	double key;
	if (m < n) {
		pivot = rnd(m, n);
		swap(&(sort[m]), &(sort[pivot]));

		key = pop->ind[sort[m]].affinity;
		i = m + 1;
		j = n;
		while (i <= j) {
			while ((i <= n) && (pop->ind[sort[i]].affinity <= key))
				i++;
			while ((j >= m) && (pop->ind[sort[j]].affinity > key))
				j--;
			if (i < j)
				swap(&(sort[i]), &(sort[j]));
		}
		// swap two elements
		swap(&(sort[m]), &(sort[j]));
		// recursively sort the lesser list
		myqsort_affinity(pop, m, j - 1, sort);
		myqsort_affinity(pop, j + 1, n, sort);

	}
	return;
}
