/*
 * funct.c
 *
 *  Created on: Mar 30, 2011
 *      Author: Thomas PIERRARD
 */
# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "datastruct.h"

double max(double a, double b) {
	return ((a>=b)? a : b);
}
double min(double a, double b) {
	return ((a>=b)? b : a);
}
double eucl_d(individual * a, individual * b) {
	int i;
	double distance;

	distance = 0;
	for (i = 0; i < nobj; i++) {
		distance += pow(a->obj[i] - b->obj[i], 2.0);
	}
	return (sqrt(distance));
}

float box_muller(float m, float s)	/* normal random variate generator */
{				        /* mean m, standard deviation s */
	float x1, x2, w, y1;
	static float y2;
	do {
		x1 = 2.0 * randomperc() - 1.0;
		x2 = 2.0 * randomperc() - 1.0;
		w = x1 * x1 + x2 * x2;
	} while ( w >= 1.0 );
	w = sqrt( (-2.0 * log( w ) ) / w );
	y1 = x1 * w;
	y2 = x2 * w;

	return( m + y1 * s );
}


double absreal(double a) {
	if (a < 0)
		return (-a);
	else
		return (a);
}

// Make a Comparison to determine if the solutions are the same
//Return:
// 0.- If they are different
// 1.- If they are equal
int same(individual * a, individual * b) {
	int i;
	for (i = 0; i < nobj; i++) {
		if (a->obj[i] < b->obj[i])
			return 0;
		else if (b->obj[i] < a->obj[i])
			return 0;
	}
	return 1;
}

void swap(int *x, int *y) {
	int temp;
	temp = *x;
	*x = *y;
	*y = temp;
}

/* Routine to copy an individual 'ind1' into another individual 'ind2' */
void copy_ind(individual *ind1, individual *ind2) {
	int i;
	ind2->rank = ind1->rank;
	ind2->constr_violation = ind1->constr_violation;
	ind2->affinity = ind1->affinity;
	if (nreal != 0) {
		for (i = 0; i < nreal; i++) {
			ind2->xreal[i] = ind1->xreal[i];
		}
	}
	for (i = 0; i < nobj; i++) {
		ind2->obj[i] = ind1->obj[i];
	}
	if (ncon != 0) {
		for (i = 0; i < ncon; i++) {
			ind2->constr[i] = ind1->constr[i];
		}
	}
	return;
}
