/*
 * hyper.c
 *
 *  Created on: Mar 23, 2011
 *      Author: Thomas PIERRARD
 */
# include <stdio.h>
# include <stdlib.h>
#include <math.h>

# include "datastruct.h"

// function that take a population of size N and keep only k elements
// with k <= N
// result is shown in sort[i]

void crowd(population * pop, int k) {
	double min, max, leftn, rightn;
	int i, j, o, l, selected;
	double minr, maxr, range;

	selected = pop->size;
	do {
		min = INF;
		max = -INF;
		j = 0;
		for (o = 0; o < nobj; o++) {

		
			//find range and minimum for normalization :
			minr = INF;
			maxr = -INF;
			for (l = 0; l < pop->size; l++) {
				if (pop->ind[l].obj[o]<minr) minr = pop->ind[l].obj[o];
				if (pop->ind[l].obj[o]>maxr) maxr = pop->ind[l].obj[o];
			}
			range = maxr-minr;
			// ---------------------------------------
			for (i = 0; i < selected; i++) sort[i] = i;
			myqsort(pop, 0, selected - 1, o, sort);
			for (j = 1; j < selected-1; j++) {
				leftn = ((pop->ind[sort[j - 1]].obj[o])-minr)/range;
				rightn = ((pop->ind[sort[j + 1]].obj[o])-minr)/range;
				pop->ind[sort[j]].affinity += (double) pow((double) (rightn
						- leftn), 2.0);
			if (pop->ind[sort[j]].affinity>max) max = pop->ind[sort[j]].affinity;
			}
			pop->ind[sort[0]].affinity += max;
			pop->ind[sort[selected-1]].affinity += max;
		}
		for (i = 0; i < selected; i++) {
			pop->ind[i].affinity = sqrt(pop->ind[i].affinity);
		}
		for (i = 0; i < selected; i++) {
			if (pop->ind[i].affinity < min) {
				min = pop->ind[i].affinity;
				j = i;
			}
		}
		// on supprime l'element (j) qui a la plus petite crowding distance
		copy_ind(&(pop->ind[selected-1]),
				&(pop->ind[j]));
		selected--;
	} while (selected != k);
}


void hyperv(population * pop, int k) {
	double min, max, self, neigh;
	int i, j, o, l, selected;
	double minr, maxr, range;
	
	selected = pop->size;
	
	do {

		min = INF;
		max = -INF;
		j = 0;
		for (o = 0; o < nobj; o++) {

			//find range and minimum for normalization :
			minr = INF;
			maxr = -INF;
			//printf("selected : %d\n",selected);
			for (l = 0; l < selected; l++) {
				//printf("pop->ind[%d].obj[%d] : %f\n",k,o,pop->ind[l].obj[o]);
				if (pop->ind[l].obj[o]<minr) minr = pop->ind[l].obj[o];
				if (pop->ind[l].obj[o]>maxr) maxr = pop->ind[l].obj[o];
			}
			range = maxr-minr;
			//printf("range : %f %f %f\n", range, minr, maxr);
			// ---------------------------------------
			for (i = 0; i < selected; i++) sort[i] = i;
			myqsort(pop, 0, selected - 1, o, sort);
			for (j = 1; j < selected-1; j++) {
				self = (pop->ind[sort[j]].obj[o]-minr)/range;
				neigh = (pop->ind[sort[j + 1]].obj[o]-minr)/range;
				pop->ind[sort[j]].affinity *= absreal(neigh-self);
				if (pop->ind[sort[j]].affinity>max) max = pop->ind[sort[j]].affinity;
			}
			pop->ind[sort[0]].affinity += max;
			pop->ind[sort[selected-1]].affinity += max;
		}

		for (i = 0; i < selected; i++) {
			if (pop->ind[i].affinity < min) {
				min = pop->ind[i].affinity;
				j = i;
			}
		}
		// on supprime l'element (j) qui a le plus petit hypervolume
		copy_ind(&(pop->ind[selected-1]),&(pop->ind[j]));
		selected--;
		//printf("selected avant: %d %d\n",selected, k);
	} while (selected != k);
	//printf("end while\n");
}


