/*
 * clmut.c
 *
 *  Created on: Mar 1, 2011
 *      Author: Thomas PIERRARD
 */
# include <stdio.h>
# include <stdlib.h>

# include "datastruct.h"

// Read individuals not yet ranked and store it in frontPtr
int read_ind(int **front, population * pop) {
	int i, sol;
	sol = 0;
	for (i = 0; i < pop->size; i++) {
		if (pop->ind[i].rank == -1) {
			(*front)[sol] = i;
			sol++;
		}
	}
	return sol;
}

// Read the solutions from the front1 and store the nondominated in front2
// Return the number of nondominated solutions
int find_ndf(int * front1, int nofront1, int ** front2, population * pop) {

	// TO TRANSLATE !
	int i, j, flag;
	int nodominados = 0;
	int frente[nofront1];
	(*front2) = malloc(nofront1 * sizeof(int));

	frente[nodominados++] = front1[0];
	for (i = 1; i < nofront1; i++) {
		flag = 1;
		for (j = 0; j < nodominados; j++) {
			if (dominate(&(pop->ind[front1[i]]), &(pop->ind[frente[j]])))
				frente[j--] = frente[--nodominados];
			else if (dominate(&(pop->ind[frente[j]]), &(pop->ind[front1[i]]))) {
				flag = 0;
				break;
			}
		}
		if (flag) { // Check if the solution is in the Nondominated Population
			if (nodominados == 0)
				frente[nodominados++] = front1[i];
			for (j = 0; j < nodominados; j++) {
				flag = 1;
				if (same(&(pop->ind[frente[j]]), &(pop->ind[front1[i]]))) {
					flag = 0;
					break;
				}
			}
			if (flag) // If the solution is not in the nondominated set, then it is added
				frente[nodominados++] = front1[i];
		}
	}
	for (i = 0; i < nodominados; i++) {
		(*front2)[i] = frente[i];
	}
	return nodominados;
}

void dominated_sort(population * pop) {

	int i, solutions, nondominated, rank, sum;
	int *front1, *front2;

	for (i = 0; i < pop->size; i++) {
		pop->ind[i].rank = -1;
	}

	front1 = malloc(pop->size * sizeof(int));

	rank = 0;
	sum = 0;

	while (sum < pop->size) {

		solutions = read_ind(&front1, pop);

		nondominated = find_ndf(front1, solutions, &front2, pop);

		for (i = 0; i < nondominated; i++)
			pop->ind[front2[i]].rank = rank;

		free(front2);
		rank++;
		sum += nondominated;
	}
	free(front1);
}
